Unit AFP0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP0C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex);

implementation

procedure AFP0C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex);
var
I,J,B,F :Integer;
G,Y,C,O,R,S,BD,BE,BM :Real;
H,BC :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23;
begin
for B:=1 to M do
 begin
  if ( B <> N ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := Cmplx(0.0,0.0);
  goto _23;
_1:
  for I:=B to N do
   begin
    W[I-1] := A[(I-1)+(B-1)*N];
_2:
   end;
  C := 0.0;
  for I:=B to N do
   begin
    BD := Creal(W[I-1]);
    BE := Aimag(W[I-1]);
    BD := Abs(BD);
    BE := Abs(BE);
    if ( BD-BE ) < 0
     then goto _4
     else if ( BD-BE ) > 0
           then goto _3
           else goto _3;
_3:
    Y := BD;
    goto _5;
_4:
    Y := BE;
_5:
    if ( Y = 0.0 ) 
     then goto _6;
    BD := BD/Y;
    BE := BE/Y;
    BD := BD*BD+BE*BE;
    Y := Y*Sqrt(BD);
_6:
    if ( C >= Y ) 
     then goto _7;
    C := Y;
_7:
   end;
  if ( C = 0.0 ) 
   then goto _22;
  G := 0.0;
  for I:=B to N do
   begin
    O := 0.0;
    BM := Creal(W[I-1])/C;
    O := O+BM*BM;
    BM := Aimag(W[I-1])/C;
    O := O+BM*BM;
    G := G+O;
_8:
   end;
  C := Sqrt(G)*C;
  G := 1.0/C;
  for I:=B to N do
   begin
    W[I-1] := MulC(W[I-1],Cmplx(G,0.0));
_9:
   end;
  R := Creal(W[B-1]);
  S := Aimag(W[B-1]);
  R := Abs(R);
  S := Abs(S);
  if ( R-S ) < 0
   then goto _11
   else if ( R-S ) > 0
         then goto _10
         else goto _10;
_10:
  G := R;
  goto _12;
_11:
  G := S;
_12:
  if ( G = 0.0 ) 
   then goto _13;
  R := R/G;
  S := S/G;
  R := R*R+S*S;
  G := G*Sqrt(R);
_13:
  if ( G <> 0.0 ) 
   then goto _14;
  H := Cmplx(1.0,0.0);
  W[B-1] := Cmplx(1.0,0.0);
  goto _16;
_14:
  H := DivC(W[B-1],Cmplx(G,0.0));
  W[B-1] := AddC(W[B-1],H);
  G := 1.0/Sqrt(1.0+G);
  for I:=B to N do
   begin
    W[I-1] := MulC(W[I-1],Cmplx(G,0.0));
_15:
   end;
_16:
  H := MulC(SubC(Cmplx(0.0,0.0),Cmplx(C,0.0)),H);
  for I:=B to N do
   begin
    A[(I-1)+(B-1)*N] := W[I-1];
_17:
   end;
  if ( B = M ) 
   then goto _21;
  F := B+1;
  for J:=F to M do
   begin
    BC := Cmplx(0.0,0.0);
    for I:=B to N do
     begin
      BC := AddC(BC,MulC(A[(I-1)+(J-1)*N],Conjg(W[I-1])));
_18:
     end;
    for I:=B to N do
     begin
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(BC,W[I-1]));
_19:
     end;
_20:
   end;
_21:
  W[B-1] := H;
_22:
 end;
_23:
end;

end.
